unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormResize(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

function LongestLabel(Labels: array of TLabel): TLabel;
var
  ALabel: TLabel;
  AWidth, ResultWidth: Integer;
begin
  Result := nil;
  ResultWidth := -1;
  for ALabel in Labels do
    if Assigned(ALabel) then
    begin
      AWidth := ALabel.Canvas.TextWidth(ALabel.Caption);
      if not Assigned(Result) or (AWidth > ResultWidth) then begin
        ResultWidth := AWidth;
        Result := ALabel;
      end;
    end;
end;

{ TForm1 }

procedure TForm1.FormResize(Sender: TObject);
var
  ALabel: TLabel;
  AWidth: Integer;
begin
  ALabel := LongestLabel([Label1, Label2, Label3, Label4, Label5]);
  Edit1.AnchorSide[akLeft].Control := ALabel;
  AWidth := ClientWidth
            - 10 // left label space
            - ALabel.Width // longest label
            - 10 // left first edit space
            - 10 // left second edit space
            - 10; // right second edit space;
  AWidth := AWidth div 2;
  Edit1.Width := AWidth;
end;

end.

